

#define  VERSION "2024_1208"
//rev  2024-1106
//#define  VERSION "2021_02_03"
////  suivre   Oled_Showstr -> dans Ram buffer
// add circle
//#define  VERSION "2021_02_02"
// add rectangle et lignes
//#define  VERSION "2020_08_26"
// correction bug draw sinusoid ...drawpixel et Refresh_OLED :  K as Byte instead of Word
//#define  VERSION "2020_02_08"
// uart bad avec FOSC Q32MHZ
//#define  VERSION "2020_02_07"
// avec FOSC Interne 16MHz
// 15 car maxi en mode taille 2
//#define  VERSION "2020_01_19"
// test mode 2 .. si le texte depasse la largeur ecran continue en dessous
// afficheimages Bit Map OK
//#define VERSION "191125"
// test OK

//#define VERSION "191120"
#define DIRECTORY  "C:\\_MikroC\\_18F26K22_Test_Mini_OLED_I2C_20x10mm_I2C_2024"
#define PROJECT " Mini_OLED_128x32_25x10mm_I2C1_HW_MC_18F26K22_2024.mcppi"
#define SOURCE " TEST_Mini_OLED_SSD1306_128x32_with_I2C1_HW_MikroC_18F26K22_"
#define OTHERS " BMP_images_128x32_2021.inc \r\n OLED_128x32_I2C1_2021_02.c et *.h\r\n OLED_128x32_Tables_2021_02.h"

#define PROCESSOR "18F26K22"
#define POWER_SUPPLY " 3.6 V"
#define DEVICES  " Mini OLED DISPLAY IIC I2C 0.91  128x32  25x10mm"
#define EEPROM  "No....ihex"
#define FOSC_INTERNE

 #ifdef   FOSC_INTERNE
 #define FOSC " Interne 16 MHz"
  #define CONFIG "P18F26K22_Fosc_Interne_16MHz.cfgsch"
 #else   
 #define CONFIG "P18F26K22_Base_Fosc_Q32MHz.cfgsch"
 #define FOSC " Q 32Mhz"
 #endif
 

/* Config bit  :
 PIC18F26k22_FOSC_interne_16MHZ.cfgsch
CONFIG1H : $300001 : 0x0028
CONFIG2L : $300002 : 0x0018
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BF
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040

*/

#define Word unsigned int
#define Byte unsigned char
#define SSD1306_HARD_I2C1
#define  SSD1306_128_32
#define SSD1306_LCDWIDTH     128
#define  SSD1306_LCDHEIGHT    32



const char logo16_glcd_bmp[] =
{ 0b00000000, 0b11000000,
  0b00000001, 0b11000000,
  0b00000001, 0b11000000,
  0b00000011, 0b11100000,
  0b11110011, 0b11100000,
  0b11111110, 0b11111000,
  0b01111110, 0b11111111,
  0b00110011, 0b10011111,
  0b00011111, 0b11111100,
  0b00001101, 0b01110000,
  0b00011011, 0b10100000,
  0b00111111, 0b11100000,
  0b00111111, 0b11110000,
  0b01111100, 0b11110000,
  0b01110000, 0b01110000,
  0b00000000, 0b00110000 };


#define CR 13
#define LF 10
#define Byte unsigned char


const code char mesg0[]=" Mikroc 7.6.0 "PROCESSOR" \r\n";
const code char mesg1[]=" Directory : "DIRECTORY" \r\n";
const code char mesg2[]=" Projet : "PROJECT"\r\n";
const code char mesg3[]=" Source : "SOURCE"_"VERSION".c \r\n";
const code char mesg4[]=" DEVICE : "DEVICES" \r\n";
const code char mesg5[]=" I2C1 HW avec MikroC Library ,Terminal pour debug et Visu programme\r\n";
const code char mesg6[]= " Alim ="POWER_SUPPLY"\r\n";
const code char mesg7[]=" FOSC= "FOSC"\r\n";
const code char mesg8[]=" Autres : "OTHERS"\r\n";
const code char mesg9[]=" ";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};

#define MAXLEN2 128
#define MAXLEN_BUFFER1 128
#define OLED_ADDRESS   0x78
#define ON 0
#define OFF 1
// caraters speciaux  , attention RESPECTER la case ( majuscule/minusules)
#define Point 0
#define Fleche_Bas 1
#define Fleche_Haut 2
#define Degre 3

#define Vide 0
#define Plein 1

sbit Led_Rouge at LATA4_bit;
sbit Led_Rouge_Dir at TRISA.B4;
sbit SQA at LATC1_bit;
sbit SQA_Dir at TRISC.B1;

unsigned char Table_Sinus_128_Steps[]=
 {
 // =SIN(PI()*E6*8/180)*15 +  macro excel   => result lignes  G6  G12
15,17,19,21,23,25,26,27,28,29,30,30,30,30,29,28,
27,25,24,22,20,18,16,14,12,10,8,6,5,3,2,1,
0,0,0,0,1,2,3,4,5,7,9,11,13,15,17,19,
21,23,25,26,27,28,29,30,30,30,30,29,28,27,25,24,
22,20,18,16,14,12,10,8,6,5,3,2,1,0,0,0,
0,1,2,3,4,5,7,9,11,13,15,17,19,21,23,25,
26,27,28,29,30,30,30,30,29,28,27,25,24,22,20,18,
16,14,12,10,8,6,5,3,2,1,0,0,0,0,1,2

};

unsigned char RamBuffer[512];           // 32 lignes de 128 bytes

volatile unsigned char buffer1[MAXLEN_BUFFER1];
volatile unsigned int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile unsigned int Index1;
volatile unsigned int CptErr;

volatile int Flag_Timer1;
volatile unsigned int Cpt1;
volatile unsigned int Max_Timer1;

int i,j,k,l,m,n;
char TEXTE[128];
char * txt;
char CRam1[128];
char cx;
char *p1;
char *p2;

void Init_Hardware(void) ;
void strConstRamCpy(unsigned char *dest, const code char *source);
void Init_Hardware(void) ;
void CRLF1(void);
void UART1_Write_CText(const char *txt);
char check_device(unsigned int dev_address);
void Float2Ascii (float x, unsigned char *str,char precision);

#include "BMP_images_128x32_2021.inc"
#include "OLED_128x32_I2C1_2021_02.h"


 void Interrupts() iv 0x0008 ics ICS_AUTO
 {
 if ( (RC1IE_bit==1) && ( RC1IF_bit==1))
   {
   //TXREG1='$';
   // traitement separe des erreurs de COM
    // c1 = UART1_Read();
     c1=RCREG1;
      if (RCSTA1.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA1.CREN = 0 ;
       c1 = RCREG1;
       RCSTA1.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA1.FERR==1 )
      {
      RCSTA1.SPEN = 0 ;
      RCSTA1.SPEN= 1 ;
      CptErr++;
       c1 = RCREG1;
      }
     if ((c1==CR) || (i1 > MAXLEN_BUFFER1-2))
      {
      Flag_Buffer1=1;
      if (i1 > MAXLEN_BUFFER1-2)  Flag_Buffer1=2;
      PIE1.RC1IE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {

        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
   }
   // -----  timer 1  ----------------
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1--;

     if (Cpt1 <1)   // x100 ms  @16MHz
       {
        TMR1IE_bit=0; // stop comptage  timer1
        TMR1ON_bit=0;
        Flag_Timer1=1;
      }
     TMR1H         = 0x3C;
     TMR1L         = 0xB0;
     TMR1IF_bit=0;
   }

  }


unsigned char check_device(unsigned char dev_address)
{
char Etat;
 SQA=1;
I2C1_Start();
SQA=0;
_asm nop;
SQA=1;
if(I2C1_Wr(dev_address)!=0 )
 {
  UART1_Write('.'); //_CText(" is not found\r\n");
  Etat=0;
 }
 else
 {

 strConstRamCpy(txt,"\r\n Device at adresse : ");
 k=strlen(txt);
 ByteToStr(dev_address,CRam1);
  strcat(txt+k,CRam1);
  UART1_Write_Text(txt);
  UART1_Write_CText(" found OK\r\n");
  Etat=1;
  }
I2C1_Stop();
SQA=0;
 return Etat;
}


void Arme_Timer1(int  Max_Timer1)
{
   // 100mS * Max_Timer1
  T1CON         = 0x30;
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
  Cpt1=  Max_Timer1;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IF_bit  = 0;
  TMR1IE_bit= 1;
  }


void Init_Timer1(void)
 {
//Timer1  FOSC=8MHz
//Prescaler 1:4; TMR1 Preload = 15536; Actual Interrupt Time : 100 ms
  T1CON         = 0x21;
 // TMR1CS1_bit=0; // FOSC/4
 // TMR1CS0_bit=0;
  T1RD16_bit=1;
 // T1CKPS1_bit=1;  //Prescaler 1:8
 // T1CKPS0_bit=1;
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
   TMR1IF_bit  = 0;
  TMR1IP_bit=1;   // high level interrupt
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}


void Float2Ascii (double x, unsigned char *str,char precision)
{
 // converts a floating point number to an ascii string
 // version limite  5 decimales maximum
 // x is stored into str, which should be at least 30 chars long
 int ie, i, k, ndig;
 double y;
 if (precision>=5) precision=5;  else precision++;
 ndig =   precision;

 ie = 0;
 // if x negative, write minus and reverse
 if ( x < 0.00000)
 {
   *str++ = '-';
   x = -x;
 }
 // put x in range 1 <= x < 10
 if (x > 0.000000) while (x < 1.000000)
 {
   x *= 10.000;                // a la place de =*
   ie--;
 }
 while (x >= 10.0000)
 {
   x = x/10.0000;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.0000;
 x += y/2.0000;
 if (x >= 10.0000) {x = 1.0000; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0000;
  }
 *str = '\0';
}


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
      Delay_us(5);
}

 void Init_Hardware()
{
  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  SQA_Dir=0;  //RC1;
  SQA=0;

     // SPI bit BANG pour Matrices MAX7219
 //SPI_CS_Dir=0;//    at TRISC0_bit;
 //SPI_CLOCK_Dir=0;// at TRISC2_bit;
 //SPI_CLOCK=0; //     at LATC2_bit;
 //SPI_DOUT_Dir=0; //  at TRISC1_bit;
 //SPI_DOUT=1; //      at LATC1_bit;

  PORTA = 0b00111111;
  ANSELA=0;
  TRISA = 0b11101111 ;   // PORTA is RA0=1=OWS   RA1=1=analog input  RA2=input RA3,  RA4=Output RA5=input
  CCP5CON=0;

  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }


 void Raz_Buffer1()  // UART
{
      // nettoye le buffer
      for(Index1=0;Index1<MAXLEN_BUFFER1-1;Index1++)  buffer1[Index1]=0;
      i1=0;
      Index1=0;
      c1=0;
      Flag_Buffer1 =0;
         RCSTA1.CREN=0 ;
        RCSTA1.CREN=1 ;
        PEIE_bit=1;
        c1=RC1REG;
        RC1IE_bit = 1 ;

}


 void Wait_Keyb(int T)
  { char Tx[8];
    int T1;
    Led_Rouge=~Led_Rouge;
    if (T>999) T=999;
    T1=T;
    Raz_Buffer1() ;
    Arme_Timer1(T);
    UART1_Write_CText(" ... Waiting Keyboard Touch for <");

    if (T1/100>0) *(Tx)=T1/100+48;  else *(Tx)=' ';
       T1=T1%100;
     if (T1/10>0) *(Tx+1)=T1/10+48;
       else *(Tx+1) ='0';
     Tx[2]=0x2C;
     Tx[3]= T1%10+48;
     Tx[4]=0;
     //    IntToStr(T,CRam1);
    //   Ltrim(CRam1);
     //  UART1_Write_Text(CRam1);
    //UART1_Write_CText(" x 100mS >\r\n");
      UART1_Write_Text(Tx);
      UART1_Write_CText(" Sec >\r\n");
    while ( (Flag_Buffer1==0) && (Flag_Timer1==0));
    Flag_Timer1=0;
    Flag_Buffer1=0;
    CRLF1();
 }



// *************************************************************

void lcd_drawPixel(int x, signed int y,Byte color)
{     int k;
        if( x > 127 || y > 31) return; // out of Display
         k= (y / 8) * 128 +x ;
        if( color == 1)
        k= k | (1 << (y % 8));
        else
         k= k  & (~ (1 << (y % 8)));
         RamBuffer[(y / 8) * 128 +x] =k;

}

// main function
void main()
{

  #ifdef FOSC_INTERNE
  // 1MHz par defaut
  // OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur à 16Mhz
  // OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur à 8Mhz
  OSCTUNE=0;
  OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur = 16Mhz
 // OSCCON = 0b01110000  ; //0x72 ;     //Oscillateur = 16Mhz *4
 // OSCTUNE.PLLEN=1 ;   // =1 => FOSC x 4
  OSCCON2=0;
  //while (OSCCON.HFIOFS==0); // wait stable oscillator
  #else
  // Q=32Mhz
  #endif
  Delay_ms(100);
  Init_Hardware() ;
  for(i=0;i<512;i++) RamBuffer[i]=0;

  
  for (i=0;i<2;i++)
  {
  Led_Rouge=ON;
  Delay_ms(200);
    Led_Rouge=OFF;
  Delay_ms(200);
  }

    
  txt=&TEXTE[0];
  UART1_Init(115200);
  Delay_ms(100);
  CRLF1();
  // presentation sur UART1

  UART1_Write_CText (" Presentation : \r\n");
  for(i=0;i<9;i++)
  {
     UART1_Write_CText(Messages[i]);
   }
  Delay_ms(1000);
  CRLF1();
  UART1_Write_CText("GO\r\n");

   UART1_Write_CText(" Init Interrupt Timer1  & UART RX \r\n");
   IPEN_bit=1 ;
   IPR1.RC1IP=1;
   PIR1.RC1IE=1;
   RCSTA1.CREN=1;
   PEIE_bit = 1;          // Enable Peripheral interrupt
   GIE_bit  = 1;         // Enable Global interrupt
   k=0;


   UART1_Write_CText(" Test interrupt Timer1  20 x 100 msec soit 2sec \r\n" );

   Init_Timer1();
   Arme_Timer1(20);
   TXREG1='$';
   CRLF1();
   while(Flag_Timer1==0);
   TXREG1='#';
   CRLF1();
   k=0;

    GIE_bit  = 0;
  UART1_Write_CText(" I2C1 init\r\n" );
   I2C1_Init(100000);
   Delay_ms(500);

  //   to do once to check or discover adresse of device
  for (i=32;i<254;i=i+2)
   {
   cx= check_device(i) ;
   Delay_ms(100);
   }
  // nota mettre un STOP avant de tester l'adresse device => impose un Nack au dpart
   I2C1_Stop();

   CRLF1();
   UART1_Write_CText(" OLED SSD1306 128x32 I2C,  initialis (en mode 2) \r\n");
   OLED_Init();
   Delay_ms(500);
   OLED_ON();
    Refresh_OLED() ;
   

    UART1_Write_CText(" OLED CLS \r\n");
    OLED_CLS();
    GIE_bit  = 1;
    
    UART1_Write_CText(" Test consommation du LCD OLED Allum 100% ON  (13.6mA sous 3.3V)\r\n");
    OLED_Fill(0xFF);
    Wait_Keyb(20) ;

    UART1_Write_CText(" Test consommation du  LCD OLED  ETEINT (1.53mA sous 3.3V) \r\n");
    OLED_Fill(0x00);
    Wait_Keyb(20) ;

    OLED_CLS();
    UART1_Write_CText(" Affiche Texte de 21 cars par ligne (Taille mini= 1) :\r\n ABCDEFGHIJKLMNOPQRSTU\r\n");
                        //123456789012345678901
     OLED_SetPos(0,0);
     strConstRamCpy(txt, "* * * * * * * * * * *");
     OLED_ShowStr(0 ,0,txt,1);
     strConstRamCpy(txt,"OLED Size 128x32 25x10");
     OLED_ShowStr(0 ,1,txt,1);
     strConstRamCpy(txt,"I2C Hard MC 02/02/2021");
     OLED_ShowStr(0 ,2,txt,1);
     strConstRamCpy(txt, "* * * * * * * * * * *");
     OLED_ShowStr(0 ,3,txt,1);
     Wait_Keyb(20) ;



  do
    {
    RAZ_Ram_Buffer();

    OLED_CLS();
    UART1_Write_CText(" Affiche lettres A B C ...Q \r\n");
    UART1_Write_CText(" Write_Char_At(X en pixel (0  127), ligne Y (0  3),code ascii char)\r\n");
    SQA=1;
    Write_Char_At(0,0,'A');
    SQA=0;
    Write_Char_At(8,1,'B');
    Write_Char_At(16,2,'C');
    Write_Char_At(24,3,'D');
    Write_Char_At(32,3,'E');
    Write_Char_At(40,2,'F');
    Write_Char_At(48,1,'G');
    Write_Char_At(56,0,'H');
    Write_Char_At(56,1,'I');
    Write_Char_At(64,2,'J');
    Write_Char_At(72,3,'K');
    Write_Char_At(80,3,'L');
    Write_Char_At(88,3,'M');
    Write_Char_At(96,2,'N');
    Write_Char_At(104,1,'O');
    Write_Char_At(112,0,'P');
    Write_Char_At(120,1,'Q');
    Wait_Keyb(20);

     OLED_CLS();
     UART1_Write_CText(" Affiche Texte de 21 cars par ligne (Taille mini= 1) :\r\n ABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n");
      strConstRamCpy(txt,"Affiche 21 car.size=1");
      OLED_ShowStr(0 ,0,txt,1);
        Wait_Keyb(15) ;
      strConstRamCpy(txt,"ABCDEFGHIJKLMNOPQRSTUVWXYZ..etc");
      OLED_ShowStr(0 ,2,txt,1);
      Wait_Keyb(15) ;

      OLED_CLS();
      UART1_Write_CText(" Affiche 16 cars (Taille= 2) :0123456789012345 at x=0, ligne 2 \r\n");
       strConstRamCpy(txt,"Aff.16 chr size2");
      OLED_ShowStr(0 ,0,txt,2);
        Wait_Keyb(15) ;
      txt=&TEXTE[0];
      strConstRamCpy(txt,"0123456789012345");
      OLED_ShowStr(0,2,txt,2);
       Wait_Keyb(20);

       OLED_CLS();
      strConstRamCpy(txt,"01234567");
      UART1_Write_CText(" Affiche 8 cars (Taille= 2): 01234567 at x=0,64, ligne 0,2 \r\n");
      OLED_ShowStr(0,0,txt,2);
       OLED_ShowStr(64,2,txt,2);
      Wait_Keyb(20);
      
      OLED_CLS();
      UART1_Write_CText(" Affichage (Taille 2) de : HELLO Friends, How are you ?. at x=0 \r\n");
      strConstRamCpy(txt," HELLO Friends ");
      OLED_ShowStr(0,0,txt,2);
       strConstRamCpy(txt," How are you ?");
      OLED_ShowStr(0,2,txt,2);
       Wait_Keyb(20);
       
       OLED_CLS();
      UART1_Write_CText(" Affichage (taille = 3) de : 19.8C\r\n");
      txt=&TEXTE[0];
      strConstRamCpy(txt,"19.82");
      OLED_ShowStr(0,0,txt,3);
      Wait_Keyb(30) ;
      
      OLED_CLS();
      strConstRamCpy(txt,"Write 4 car.speciaux ");
      OLED_ShowStr(0,0,txt,1);
      UART1_Write_CText(" Write 4 caracteres speciaux \r\n");
      Affiche_Car_8x8(0,2,Point);
      Affiche_Car_8x8(20,2,Fleche_Bas);
      Affiche_Car_8x8(40,2,Fleche_Haut);
      Affiche_Car_8x8(60,2,Degre);
      Write_Char_At(70,2,'C'); // char table ascii
      Write_Char_At(96,2,124); // dernier char de la table ascii
      Write_Char_At(104,2,'C'); // char table ascii
      Wait_Keyb(20);

      OLED_CLS();
      UART1_Write_CText(" Big_affichage( unsigned char posX, unsigned char N )\r\n");
      strConstRamCpy(txt,"0123456");
      for (i=0;i<7;i++)   Big_affichage(16*i,i);
      Wait_Keyb(20) ;
    
      OLED_CLS();
      UART1_Write_CText(" Affichage Mixte de : 21.9C\r\n");
      i=0;
      Big_affichage(0,11);  i=i+16;
      Big_affichage(i,2);  i=i+16;
      Big_affichage(i,1);  i=i+16;
      Big_affichage(i,10);  i=i+16;
      Big_affichage(i,9);   i=i+20;
      Affiche_Car_8x8(i,1,Degre) ;i=i+16;
      Write_Char_At(i,1,'C');
      Led_Rouge=~Led_Rouge;
      Wait_Keyb(20) ;
      
      OLED_CLS();
      UART1_Write_CText(" Affichage Image Provider RPC 1 \r\n");
      OLED_DrawBMP(0,0,128,4,IMAGE);
      Wait_Keyb(15) ;
   
      OLED_CLS();
      UART1_Write_CText(" Affichage Image paulfjujo \r\n");
      OLED_DrawBMP(0,0,128,4,paulfjujo);
      Wait_Keyb(15) ;

      OLED_CLS();
      UART1_Write_CText(" Affichage Image Adafruit \r\n");
      OLED_DrawBMP(0,0,128,4,Adafruit);
      Wait_Keyb(15) ;
      

     OLED_CLS();
     UART1_Write_CText(" Affichage sinusoide \r\n");
     RAZ_Ram_Buffer();
    // for (i=0;i<127;i++)  OLED_Draw_Pixel(i,Table_Sinus_128_Steps[i],1);
     for (i=0;i<127;i++)  Draw_Pixel(i,Table_Sinus_128_Steps[i],1);
     Refresh_OLED() ;
     Wait_Keyb(20) ;
    
     UART1_Write_CText(" Draw Pixels at  1,1,126,30 \r\n");
     OLED_CLS();
     RAZ_Ram_Buffer();  //123456789012345678901   <- Gabarit
     strConstRamCpy(txt, "Pixels at 2,2,125,29");
     OLED_ShowStr(0 ,1,txt,1);
     Draw_Pixel(2,2,1);
     Draw_Pixel(125,0,1);
     Draw_Pixel(2,29,1);
     Draw_Pixel(125,29,1);
     Refresh_OLED() ;
     Wait_Keyb(20) ;
      
     UART1_Write_CText(" Draw Horiz.Line with Draw_Pixel  at  y=6 et y=22\r\n");
     OLED_CLS();
     RAZ_Ram_Buffer();
     for(i=0;i<127;i++) {
       Draw_Pixel(i,6,1);
      Draw_Pixel(i,22,1);
       }
       Refresh_OLED() ;
     Wait_Keyb(20) ;
     
      OLED_CLS();
     RAZ_Ram_Buffer();
     UART1_Write_CText(" OLED_Lines diagonales  \r\n");
     OLED_Line(1,1,126,31,1);
     OLED_Line(1,31,126,1,1);
     Refresh_OLED() ;
     Wait_Keyb(20) ;


     UART1_Write_CText(" Draw rectangles (vides) at  1,1,126,30 \r\n");
     OLED_CLS();
     RAZ_Ram_Buffer();
     for (i=0;i<15;i=i+3) 
     { 
         Draw_Rectangle(1+i,1+i,126-i,31-i,Vide,1);
         Refresh_OLED() ;
         Delay_ms(500);
      }
      Wait_Keyb(25) ;

      UART1_Write_CText(" Draw rectangles (Pleins) at  1,1,126,30 \r\n");
     OLED_CLS();
     RAZ_Ram_Buffer();
     for (i=12;i>2;i=i-2) 
     {
      Draw_Rectangle(1+i,1+i,126-i,31-i,Plein,1);
      Refresh_OLED() ;
      Delay_ms(500);
     }
     Wait_Keyb(30) ;

     OLED_CLS();
     UART1_Write_CText(" Draw Cercles vides centrs \r\n");
     RAZ_Ram_Buffer();
     strConstRamCpy(txt,"Cercles");
     OLED_ShowStr(0,0,txt,1);
     strConstRamCpy(txt,"Vides");
     OLED_ShowStr(0,1,txt,1);
     for (i=4;i<17;i=i+2)
     {
     // param Draw_Circle : x,y,radius,fill,colour
      Draw_Circle(64,15,i,Vide,1);
      Refresh_OLED() ;
      Delay_ms(500);
     }
     Wait_Keyb(30) ;

      OLED_CLS();
     UART1_Write_CText(" Draw Cercles Pleins centrs \r\n");
     RAZ_Ram_Buffer();
     strConstRamCpy(txt,"Cercles");
     OLED_ShowStr(0,1,txt,1);
     strConstRamCpy(txt,"pleins");
     OLED_ShowStr(0,1,txt,1);
     for (i=4;i<17;i=i+2)
     {
     // param Draw_Circle : x,y,radius,fill,colour
      Draw_Circle(64,15,i,Plein,1);
      Refresh_OLED() ;
      Delay_ms(500);
      Draw_Circle(64,15,i-2,Plein,0);
      Refresh_OLED() ;
     }
     Wait_Keyb(30) ;


     RAZ_Ram_Buffer();
     Refresh_OLED() ;

   UART1_Write_CText("\r\n Next.. \r\n" );
   }
   while(1);
}

/*
   Presentation :
 Mikroc 7.6.0 18F26K22
 Directory : C:\_MikroC\_18F26K22_Test_Mini_OLED_I2C_20x10mm_I2C_2021
 Projet :  Mini_OLED_128x32_25x10mm_I2C1_HW_MC_18F26K22_2021.mcppi
 Source :  TEST_Mini_OLED_SSD1306_128x32_with_I2C1_HW_MikroC_18F26K22_2021_02_03.c
 DEVICE :  Mini OLED DISPLAY IIC I2C 0.91  128x32  25x10mm
 I2C1 HW avec MikroC Library ,Terminal pour debug et Visu programme
 Alim = 3.6 V
 FOSC=  Interne 16 MHz
 Autres :  BMP_images_128x32_2021.inc
 OLED_128x32_I2C1_2021_02.c et *.h
 OLED_128x32_Tables_2021_02.h

GO
 Init Interrupt Timer1  & UART RX
 Test interrupt Timer1  20 x 100 msec soit 2sec
$
#
 I2C1 init
............................................
 Device at adresse : 120 found OK
..................................................................
 OLED SSD1306 128x32 I2C,  initialis (en mode 2)
 OLED CLS
 Test consommation du LCD OLED Allum 100% ON  (13.6mA sous 3.3V)
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Test consommation du  LCD OLED  ETEINT (1.53mA sous 3.3V)
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affiche Texte de 21 cars par ligne (Taille mini= 1) :
 ABCDEFGHIJKLMNOPQRSTUVWXYZ
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affiche lettres A B C ...Q
 Write_Char_At(X en pixel (0  127), ligne Y (0  3),code ascii char)
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affiche Texte de 21 cars par ligne (Taille mini= 1) :
 ABCDEFGHIJKLMNOPQRSTUVWXYZ
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affiche 16 cars (Taille= 2) :0123456789012345 at x=0, ligne 2
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affiche 8 cars (Taille= 2): 01234567 at x=0,64, ligne 0,2
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affichage (Taille 2) de : HELLO Friends, How are you ?. at x=0
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affichage (taille = 3) de : 19.8C
 ... Waiting Keyboard Touch for < 3,0 Sec >

 Write 4 caracteres speciaux
 ... Waiting Keyboard Touch for < 0,3 Sec >

 Big_affichage( unsigned char posX, unsigned char N )
 ... Waiting Keyboard Touch for < 1,5 Sec >

 Affichage Mixte de : 21.9C
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Affichage Image Provider RPC 1
 ... Waiting Keyboard Touch for < 1,5 Sec >

 Affichage Image paulfjujo
 ... Waiting Keyboard Touch for < 1,5 Sec >

 Affichage Image Adafruit
 ... Waiting Keyboard Touch for < 1,5 Sec >

 Affichage sinusoide
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Draw Pixels at  1,1,126,30
 ... Waiting Keyboard Touch for < 2,0 Sec >

 Draw Horiz.Line with Draw_Pixel  at  y=6 et y=22
 ... Waiting Keyboard Touch for < 3,0 Sec >

 OLED_Lines diagonales
 ... Waiting Keyboard Touch for < 3,0 Sec >

 Draw rectangles (vides) at  1,1,126,30
 ... Waiting Keyboard Touch for < 3,0 Sec >

 Draw rectangles (Pleins) at  1,1,126,30
 ... Waiting Keyboard Touch for < 3,0 Sec >

 Draw Cercles vides centrs
 ... Waiting Keyboard Touch for < 3,0 Sec >


 Next..
 ===================================
 MPLABX IPE V5.30 + Pickit4
 Loading code from C:\_MikroC\_MesProjets_MikroC\_18F26K22_Test_Mini_OLED_I2C_20x10mm_I2C_2021\Mini_OLED_128x32_25x10mm_I2C1_HW_MC_18F26K22_2021.hex...
2021-02-03 09:32:34 +0100 - Hex file loaded successfully.
2021-02-03 09:32:34 +0100 - Programming...
***************************
Calculating memory ranges for operation...
Erasing...
The following memory area(s) will be programmed:
program memory: start address = 0x0, end address = 0x443f
configuration memory
Programming/Verify complete
2021-02-03 09:32:38 +0100 - Programming complete
===============================================


 0 1 mikroCPIC1618.exe -MSF -DBG -pP18F26K22 -RA -C -DL -O11111114 -fo16 -N"^C
C:\_MikroC\_MesProjets_MikroC\_18F26K22_Test_Mini_OLED_I2C_20x10mm_I2C_2021\Mini_OLED_128x32_25x10mm_I2C1_HW_MC_18F26K22_2021.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_18F26K22_Test_Mini_OLED_I2C_20x10mm_I2C_2021\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -IP"^C
C:\_MikroC\_MesProjets_MikroC\_18F26K22_Test_Mini_OLED_I2C_20x10mm_I2C_2021\" "TEST_Mini_OLED_SSD1306_128x32_with_I2C1_HW_MikroC_18F26K22_2021_02_03.c" "OLED_128x32_I2C1_2021_02.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CType.mcl" "
_Lib_CString.mcl" "
_Lib_CStdlib.mcl" "
_Lib_CMath.mcl" "
_Lib_Conversions.mcl" "
_Lib_I2C_c34b12.mcl" "
_Lib_UART_c67b67.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F26K22.c
2623 123 Compiled Successfully P18F26K22.c
0 122 Compilation Started
_Lib_Delays.c
172 123 Compiled Successfully
_Lib_Delays.c
0 122 Compilation Started TEST_Mini_OLED_SSD1306_128x32_with_I2C1_HW_MikroC_18F26K22_2021_02_03.c
0 1004 interrupt handler (Interrupts at 0x0008) TEST_Mini_OLED_SSD1306_128x32_with_I2C1_HW_MikroC_18F26K22_2021_02_03.c
489 1509 Generated baud rate is 19231 bps (error = 0.16 percent) TEST_Mini_OLED_SSD1306_128x32_with_I2C1_HW_MikroC_18F26K22_2021_02_03.c
767 123 Compiled Successfully TEST_Mini_OLED_SSD1306_128x32_with_I2C1_HW_MikroC_18F26K22_2021_02_03.c
0 122 Compilation Started oled_128x32_tables_2021_02.h
252 1163 Variable 'i' has been declared, but not used OLED_128x32_I2C1_2021_02.c
811 123 Compiled Successfully OLED_128x32_I2C1_2021_02.c
482 1164 Variable 'C1' has been eliminated by optimizer OLED_128x32_I2C1_2021_02.c
502 1164 Variable 'C1' has been eliminated by optimizer OLED_128x32_I2C1_2021_02.c
703 1164 Variable 'k' has been eliminated by optimizer OLED_128x32_I2C1_2021_02.c
0 127 All files Compiled in 219 ms
0 1144 Used RAM (bytes): 1218 (31%)  Free RAM (bytes): 2657 (69%) Used RAM (bytes): 1218 (31%)  Free RAM (bytes): 2657 (69%)
0 1144 Used ROM (bytes): 17432 (27%)  Free ROM (bytes): 48104 (73%) Used ROM (bytes): 17432 (27%)  Free ROM (bytes): 48104 (73%)
0 125 Project Linked Successfully Mini_OLED_128x32_25x10mm_I2C1_HW_MC_18F26K22_2021.mcppi
0 128 Linked in 78 ms
0 129 Project 'Mini_OLED_128x32_25x10mm_I2C1_HW_MC_18F26K22_2021.mcppi' completed: 562 ms
0 103 Finished successfully: 03 fvr. 2021, 09:32:26 Mini_OLED_128x32_25x10mm_I2C1_HW_MC_18F26K22_2021.mcppi
*/